(*!ebnf nocheck *)  (* !!! for use with Depot4-Java only !!! *)
MODULE Dp4MlModule                         (* jl 05.12.97 *)
  IMPORTS Dp4List, Dp4OP, Dp4Util:='Dp4.Util';
TYPE HVarsT = RECORD ci,cx,ti,tx: INT END;
      FlxiniT = RECORD tp5, tp6: TXT END;
      VarsT  = FLEX OF RECORD tp, x: INT END;
TYPEND;
Dp4MlModule =

GLOBVAR DCL ntL, nt1L, ntxL, impL, ntmL, gvL, TypL, VarL: Dp4List.List;
  DCL init, typnr, ct, srctxt, ebnf, ebnfe, ebnfi, UsN, UsO, Usc  : INT;
  DCL Dp4Date, RuleId                      : SYM;
  DCL HVars : HVarsT;
  DCL glob  : RECORD g, d: INT END;
  DCL Flxini: FlxiniT;
  DCL gvT  : FLEX OF TXT;
  DCL Tpdsc: FLEX OF RECORD tpx, init: INT; dsc: TXT END;
  DCL Types: FLEX OF RECORD kd, idx: INT END;
  DCL Vars : VarsT;
  DCL ModuleIdent: SYM;   DCL check, errs: INT;
VAR oi, ot, ov, om, NR, vl, ini: INT;   mid, Rids0: SYM;  Rids: FLEX OF SYM; 
LOCAL 'id'<- 'Ml4jLex','str'<-'Ml4jLex', 'num'<-'Ml4jLex', 'srcstr'<-'Ml4jLex';
 Dp4Date:= Dp4Util.Date();
 Dp4List.New(impL);  Dp4List.New(TypL); Dp4List.New(ntmL); Dp4List.New(gvL); Dp4List.New(VarL);
 Dp4List.Extend(impL,'yB')  Dp4List.Extend(impL,'yC') Dp4List.Extend(impL,'yT') Dp4List.Extend(impL,'yyPrs')
  typnr:= 10; ct:= 0;  NR:= 0; Flxini.tp5:= ''; Flxini.tp6:= '';
 ebnf:= 0; DefCom('(*', '*) '); DefCom('$2*:Dp4MlDir$(*!','*) ');  Skip();
[/(ebnf)/ Dp4List.Extend(impL,'Dp4Streams') ]
       [/om/ 'MODULE' $ !! id mid:= id_0
                     Dp4OP.WrStr('Module ');Dp4OP.WrStr(mid);Dp4OP.WrLn()]
       [/oi/ '$6IMPORTS' !! { (//!i#1;','|) id [//':=' str]
                           Dp4List.Unite(impL, id_0); } ';' ]
       [/ot/ 'TYPE' !! Dp4MlTypeDecl '$3TYPEND' !!  [//';']
                            Flxini.tp5:= Dp4MlTypeDecl_3   Flxini.tp6:= Dp4MlTypeDecl_4 ]
       [/ov/ 'VAR' $ !! Dp4MlVars ]
  vl:= Dp4List.len(VarL);
  Dp4MlRule (/1+om/ mid:= RuleId;|) ModuleIdent:= mid; Rids0:= RuleId;
  [/(om)/{/..NR/ Dp4List.Cut(VarL, vl)
                Rules:Dp4MlRule[i]; Rids[i]:= RuleId }]
  [/ini/'INIT'$ ebnfi:= 0 Inits: Dp4MlSrcExp ]
  [/(om)/ [// 'END'$ !! id (//!id_0=mid| ERROR(20)) ] ]
-> (*-------------------------------------------------------------------*)
'(* generated with Depot4/J''s Ml4 Translator of ' Ml4Date ' (c) Lampe *)\n'
'MODULE ' mid '; (* 'Dp4Date' *)\n  IMPORT yB:= Dp4Base, yC:= Dp4Chars, yT:= Dp4Tools'
  {/=5..Dp4List.len(impL)/ ',' (!i MOD 6=1; '\n     ') Dp4List.Item(impL, i) } ';\n'
  'TYPE yy000000=INTEGER;\n' [/ot/  Dp4MlTypeDecl_ ]
  (* types *)
  Dp4MlRule_2 {/..NR/ Rules_2[i]}  [/ov/ Dp4MlVars_2]
  (* variables *)
  'VAR yySYM:yB.SymbolDesc;yyCHAR: CHAR;\n'
  [/ov/ Dp4MlVars_ Dp4MlVars_5 ] Dp4MlRule_4 {/..NR/ Rules_4[i]}
  [/Dp4List.len(gvL)/ 'VAR yy10' Dp4List.Item(gvL,1)
      {/=2..Dp4List.len(gvL)/',yy10' Dp4List.Item(gvL,i)} ': yT.gIdx;\n']
  [/Dp4List.len(ntmL)/ 'VAR ' Dp4List.Item(ntmL,1) 
      {/=2..Dp4List.len(ntmL)/ ',' Dp4List.Item(ntmL,i)} ':yT.NonTerm;\n']  
  (* procedures *)
  [/ot/  Dp4MlTypeDecl_2 ] [/ov/ Dp4MlVars_3]
  Dp4MlRule_  {/..NR/ Rules_[i]}
  'PROCEDURE I*;BEGIN yT.installNT(''' Rids0 ''', yyP' Rids0 ')'
  {/..NR/ ';\n yT.InstallNT(' Rids[i] ', yyP' Rids[i] ')' }
  '\n END I;\nBEGIN\n'  
 {/..Dp4List.len(gvL)/
   ' yT.Mark(yy10' Dp4List.Item(gvL,i)',''' Dp4List.Item(gvL,i)''',''' gvT[i] ''');\n'}
 Dp4MlRule_3 {/..NR/Rules_3[i]} [/ov/ Dp4MlVars_4]
  {/..Dp4List.len(ntmL)/ ' yT.RegistNT(' Dp4List.Item(ntmL,i) ','''
       Dp4List.Item(ntmL,i) ''');\n' }
   (!Rids0# mid 'yT.ModNT(''' Rids0 ''',''' mid ''');\n' )
  {/..NR/ ' yT.ModNT(''' Rids[i] ''',''' mid ''');\n' }
 [/ini/Inits_ ';\n']
  'END ' mid '.\n'
.
(*-----------------------------------------------------------------------------*)
Dp4MlLocals =
  { (!i=1|',') s: Dp4MlStrVar[i]  '<-' t: Dp4MlStrVar[i]  }
->
  { 'yT.PushNT(' s_[i] ', ' t_[i] ');\n' }
->
  { 'yT.PopNT(' s_[i] ');\n' }
.
Dp4MlStrVar = (str| Dp4MlVarUse)
-> ( '''' str_ '''' | Dp4MlVarUse_).
Dp4MlQualId=
GLOBVAR USE ct: INT; USE impL:Dp4List.List;
   id '.' !(Dp4List.Idx(impL,id_0)#0)
   id2: id
   ct:= 0
->
   id_0'.' id2_0.

Dp4MlVars=                    (* jl 19.3.1996 *)
 GLOBVAR USE glob: RECORD g,d: INT END;
 glob.g:=0; glob.d:=0

    { [//'$3VAR' ] Dp4MlVarDecl[i] }
->
	{Dp4MlVarDecl_[i]}
->
	{Dp4MlVarDecl_2[i]}
->
	{Dp4MlVarDecl_3[i]}
->
	{Dp4MlVarDecl_4[i]}
->
	{Dp4MlVarDecl_6[i]}
->
	{Dp4MlVarDecl_7[i]}.

Dp4MlDir =
GLOBVAR USE check, ebnf: INT;
{//['no']<(//'ebnf'; ebnf:= 1-O|'check'; check:= 1-O)>}.

END Dp4MlModule
