(*!ebnf nocheck *)
MODULE Dp4MlType   (* 4.5.98 *)
IMPORTS Dp4List; 
Dp4MlType =                             
  GLOBVAR USE init, typnr: INT;
    USE TypL: Dp4List.List;
    USE Tpdsc: FLEX  OF RECORD tpx, init: INT; dsc: TXT END;
    USE Types: FLEX OF RECORD kd, idx: INT END;
    USE ct, errs: INT;
    DCL rt: INT;
  VAR in: ARRAY 40 OF INT; c1, c2, tn, inif:INT;
 
 init:= 0; Skip();
 ('$4BOOLEAN' |'$3INTEGER' | '$4REAL' | '$3SYM' |  '$3TXT' | '$3TARGET'   
 |'$3RECORD' !!
         INC(typnr); tn:= typnr; rt:= tn;
   Dp4MlFieldList[1] in[1]:= init;
   {';' Dp4MlFieldList[i+1] in[i+1]:= init; }
  '$3END'  init:= 0; {/..(N+1)/ (/c1/ !in[i]=1; init:= 1|)}
        Types[tn].kd:= 1; Types[tn].idx:= tn;
 |'FLEX' (/c1/'1' | '2'|) $ !! '$2OF' Tp:Dp4MlType; inif:= init;  init:= 1;
        INC(typnr); tn:= typnr;  rt:= ct;
        Types[tn].kd:= 3; Types[tn].idx:= ct;
 |'$3ARRAY' !! (//num:num | num:Dp4MlQualId) '$2OF' Tp:Dp4MlType
        rt:= ct;  INC(typnr);   tn:= typnr;
        Types[tn].kd:= 2; Types[tn].idx:= ct;
 | (// id1: Dp4MlQualId | id1: id <'.' id>  ERROR(18); INC(errs) ) ct:= 0
 | id1: id   tn:= Dp4List.Idx(TypL, id1_0);
        (/c2/ !tn#0; ct:= Tpdsc[tn].tpx init:= Tpdsc[tn].init 
        | ct:= 0; ERROR(18); INC(errs) )
 ) 
 (/c1/!c<7; ct:= c|!c<10; ct:= tn|)
->   (*----------------- type identifier ------------------------*)
 ('BOOLEAN' | 'INTEGER' | 'REAL' | 'yB.SymbolDesc' | 'yB.tNode' | 'yB.trgts' 
  | 'yy20' ct
  | 'yT.Flex'
  | 'yy20' ct
  | id1_1
  | id1_0 )
->   (*----------------- type definition ------------------------*) 
 (|||||
  | {/..N+1/ Dp4MlFieldList_2[i] }
    'yy20' ct '= RECORD ' Dp4MlFieldList_[1]
      {';\n' Dp4MlFieldList_[i+1] } ' END;\n'  
  | Tp_2 'yy20' ct '= POINTER TO RECORD(yT.FlxItemDesc)X:' Tp_ 
       ' END;\nyy25' ct '= ARRAY yT.FlxL OF yy20' ct ';\n'
  | Tp_2 'yy20' ct '= ARRAY ' num_1 ' OF ' Tp_ ';\n'
  | | )
->   (*------------------- procedures ---------------------------*)
 (|||||
  | (* RECORD *)
    {/..N+1/ Dp4MlFieldList_3[i]}
    'PROCEDURE yy24' ct '(VAR R:yy20' ct {/..N+1/';' Dp4MlFieldList_[i] }
    ');\nBEGIN\n' {/..N+1/';' Dp4MlFieldList_6[i] } 'END yy24' ct ';\n'
    [/init/ 'PROCEDURE yy23' ct '(VAR H: yy20' ct ');\nBEGIN\n'
      {/..N+1/ [/in[i]/ Dp4MlFieldList_4[i]]}
      'END yy23' ct ';\n' ]
  |(* FLEX *) Tp_3
   'PROCEDURE yy22' ct '():yT.FlxItem;\n'
   'VAR H: yy20' ct ';\n BEGIN NEW(H);'
        [/inif/ 'yy23' rt '(H.X);']                   (* ++ 4.5.98*)
        'RETURN H END yy22' ct ';\n'
   'PROCEDURE yy23' ct '(VAR H: yT.Flex);BEGIN yT.InitFlx(H, yy22' ct
        ')END yy23' ct ';\n'
  |(*array*) Tp_3 
    [/init/ 'PROCEDURE yy23' ct '(VAR H:yy20' ct');\nVAR i: INTEGER;\nBEGIN\n' 
    '  FOR i:= 0 TO ' num_ '-1 DO yy23' rt '(H[i]) END\nEND yy23' ct ';\n' ]
  |(*QualId*)|(*id*))
->   (*----------------- type description ------------------------*)
 ('B'|'I'|'R'|'Y'|'T'|'G' 
  | '(' {/..N+1/ Dp4MlFieldList_5[i] } ')'
  |'X' Tp_4 | num_1 Tp_4 | 'U'| (/c2/Tpdsc[tn].dsc|'?') )
->   (*------------- access variable for FLEX ---------------------*)
 (!c=8 Tp_5     (* ++ 4.5.98*)
            'VAR yy21' ct ': POINTER TO RECORD F: yy25' ct' END;\n' )
 (!c=7; {/..N+1/ Dp4MlFieldList_7[i]})     (* ++ 8.1.98*)
 (!c=9; Tp_5) 
->   (*----------- init access variable for FLEX -------------------*)
 (!c=8 Tp_6     (* ++ 4.5.98*)
        'yT.FlxAdr(yy21' ct ');\n' )
 (!c=7; {/..N+1/ Dp4MlFieldList_8[i]})     (* ++ 8.1.98*)
 (!c=9; Tp_6 ) 

.
 
Dp4MlFieldList=           (* jl 19.3.1996 *)
GLOBVAR USE init, rt, ct: INT;
    USE VarL: Dp4List.List;
    USE Vars: FLEX OF RECORD tp, x: INT END;
VAR h: SYM;

  id[1] {',' !! id[i+1]} ':' Dp4MlType
  {/..N+1/ h:= rt+id_0[i]  Dp4List.Extend(VarL, h);
    Vars[Dp4List.len(VarL)].tp:= ct }

->
  id_0[1] {',' id_0[i+1]} ':' Dp4MlType_
  
->
  Dp4MlType_2  
  
->
  Dp4MlType_3
  
->
  [/init/ {/..N+1/ 'yy23' ct '(H.' id_0[i] ');\n' }]
  
->
  {/..N+1/ Dp4MlType_4}
  
-> (* 6 *)
  {/..N+1/ 'R.'id_0[i] ':=' id_0[i] ';'}
-> (* 7 *)
 Dp4MlType_5              (*8.1.98*)
-> (* 8 *)
 Dp4MlType_6
.
 
END Dp4MlType
#
8.1.98: bug with nested FLEX removed 
4.5.98: bug with FLEX OF REC a: FLEX ... fixed(?)